// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#include "UILabel.hpp"

using namespace Dawn;

UILabel::UILabel(SceneItem *item) :
  UIComponent(item),
  text(""),
  fontSize(10.0f),
  font(nullptr)
{
}

void UILabel::updateMesh() {
  if(!this->needsRebuffering || !this->hasText) return;
  if(((Font*)this->font) == nullptr || !this->font->isReady()) return;

  // float_t width = this->width;
  // if(width == 0) width = -1;

  // std::string text = this->getGame()->localeManager.getString(key);
  this->font->buffer(
    text,
    fontSize,
    -1,
    &this->mesh,
    &this->measure
  );
  this->needsRebuffering = false;
}

void UILabel::onStart() {
  useEffect([&]{
    hasText = ((std::string)text).size() > 0;
    needsRebuffering = true;
  }, text);

  useEffect([&]{
    needsRebuffering = true;
  }, fontSize);

  useEffect([&]{
    needsRebuffering = true;
  }, font);
}