// Copyright (c) 2023 Dominic Masters
// 
// This software is released under the MIT License.
// https://opensource.org/licenses/MIT

#pragma once
#include "UIComponent.hpp"
#include "display/font/Font.hpp"

namespace Dawn {
  class UILabel : public UIComponent {
    private:
      bool_t needsRebuffering = true;
      bool_t hasText = false;

      Mesh mesh;

      void updateMesh();

    public:
      StateProperty<std::string> text;
      StateProperty<float_t> fontSize;
      StateProperty<Font*> font;
      struct Color textColor = COLOR_MAGENTA;
      struct FontMeasure measure;
      int32_t startQuad = 0;
      int32_t quadCount = -1;

      UILabel(SceneItem *item);

      void onStart() override;
  };
}